       IDENTIFICATION DIVISION.
       PROGRAM-ID. "PRINT-CONFIG".

       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT CONFIG
               ORGANIZATION IS INDEXED
               ACCESS MODE IS SEQUENTIAL
               RECORD KEY IS CONFIG-KEY.
           SELECT USERS
               ORGANIZATION IS INDEXED
               ACCESS MODE IS SEQUENTIAL
               RECORD KEY IS USER-NAME.
           SELECT CHANNELS
               ORGANIZATION IS SEQUENTIAL.

       DATA DIVISION.
       FILE SECTION.
       FD CONFIG.
       01 CONFIG-RECORD.
           03 CONFIG-KEY PIC X(16).
           03 CONFIG-VALUE PIC X(64).
       FD USERS.
       01 USER-RECORD.
           03 USER-NAME PIC X(16).
           03 USER-LEVEL PIC 9(2).
       FD CHANNELS.
       01 CHANNEL-RECORD.
           03 CHANNEL-NAME PIC X(50).

       WORKING-STORAGE SECTION.
       01 STATE PIC 9(2) VALUE 0.
           88 DONE VALUE 10.

       PROCEDURE DIVISION.
           DISPLAY "CONFIGURATION ENTRIES:"
           OPEN INPUT CONFIG.
           PERFORM PRINT-CONFIG-ENTRY UNTIL DONE.
           MOVE 0 TO STATE.
           CLOSE CONFIG.
           DISPLAY "USER ENTRIES:"
           OPEN INPUT USERS.
           PERFORM PRINT-USER-ENTRY UNTIL DONE.
           MOVE 0 TO STATE.
           CLOSE USERS.
           DISPLAY "CHANNEL ENTRIES:"
           OPEN INPUT CHANNELS.
           PERFORM PRINT-CHANNEL-ENTRY UNTIL DONE.
           MOVE 0 TO STATE.
           CLOSE CHANNELS.
           EXIT PROGRAM.

       PRINT-CONFIG-ENTRY.
           READ CONFIG NEXT RECORD
               AT END MOVE 10 TO STATE.
           IF NOT DONE THEN
               DISPLAY CONFIG-RECORD.

       PRINT-USER-ENTRY.
           READ USERS NEXT RECORD
               AT END MOVE 10 TO STATE.
           IF NOT DONE THEN
               DISPLAY USER-RECORD.

       PRINT-CHANNEL-ENTRY.
           READ CHANNELS NEXT RECORD
               AT END MOVE 10 TO STATE.
           IF NOT DONE THEN
               DISPLAY CHANNEL-RECORD.
